#if !defined(FO_EXTCLOCKSHAPE_H__FB79CEA5_568C_4287_8B25_AEF55B063FF0__INCLUDED_)
#define FO_EXTCLOCKSHAPE_H__FB79CEA5_568C_4287_8B25_AEF55B063FF0__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//------------------------------------------------------
// Description
// Author: Author Name.
//------------------------------------------------------

#define MY_CLOCK_SHAPE FO_COMP_CUSTOM + 2

class CExtClockShape : public CFODrawShape  
{
protected:
	DECLARE_SERIAL(CExtClockShape);
public:

	// constructor
	CExtClockShape();

	// Copy constructor.
	CExtClockShape(const CExtClockShape& src);

	// Destructor.
	virtual ~CExtClockShape();

	// Creates the shape and initializes the data members.
	virtual void Create(CRect &rcPos,CString strCaption = _T(""));

public:

	// Assignment operator.
	CExtClockShape& operator=(const CExtClockShape& src);

	// Creates a copy of this shape.
	virtual CFODrawShape* Copy() const;

	//Generate Shape Area
	virtual void GeometryUpdated(CFOArea* pRgn);

	// Obtain the composite of the shape.
	virtual void GetPathSimplePolygon(FOPSimpleCompositePolygon& rPoly) const;

	// Re calc extend bound rectangle,override this method to calc the extend bound rectangle of the shape
	virtual void CalcExtendBoundRect(CRect &rcBound) const;

	// Get normal spot count.
	virtual int GetNormalSpotCount() const;

	// Get plus spot count.
	virtual int GetPlusSpotCount() const;
	
	// Get the sport point of control by drag handle,calc the normal 8 control handles.
	// mpSpot -- result control handle list
	virtual void GetNormalSpotLocation(CFOPHandleList& lstHandle);

	// Get the plus spots of the control handles,override this method to calc the new position of the handle.
	// mpSpot -- result of the spot.
	virtual void GetPlusSpotLocation(CFOPHandleList& lstHandle);

	// Get rotate handle location,override this method to calc the new rotating control handle.
	// ptHandle -- result rotating control handle.
	virtual BOOL GetRotateSpotLocation(CPoint &ptHandle);

	// Get the rotating angle,override this method to drawing new rotating angle text.
	virtual int	GetRotateAngle() const;

	// Generate the editing label text.
	virtual CString GenEditingLabel();

	// Calc the label start position.
	virtual CRect CalcLabelPosition(CDC *pDC,BOOL &bFullSize) const;

	void Gen_Angle(const FOPPoint *centre, double degrees, double radius,
		FOPPoint *pt);
	
	void Gen_Hour_Handle(const FOPPoint *centre, double hours, double radius,
		FOPPoint *pt);
	
	void Gen_Min_Handle(const FOPPoint *centre, double minutes,
		double radius, FOPPoint *pt);
public:

	// Serializes the data.
	virtual void Serialize(CArchive &ar);
	
	// Save document.
	virtual BOOL SaveDocument(LPCTSTR lpszPathName);

	// Open document.
	virtual BOOL OpenDocument(LPCTSTR lpszPathName);
	
	// Get file.
	CFile *GetFile(LPCTSTR lpszFileName, UINT nOpenFlags,CFileException* pError);
	
	// Release file.
	virtual void ReleaseFile(CFile* pFile, BOOL bAbort);

public:

	//Draw flat status.

	// Draws custom tracker.
	virtual void OnDrawTrackCustom(CDC *pDC);

	// Do draw visio like bounding selection line.
	// pDC -- pointer of the DC.
	virtual void DoDrawVisioOrderLine(CDC *pDC);

	// Creates GDI objects and sets up the device context for drawing. 
	virtual void PrepareDC(CDC* pDC);

	// Draws the flat status of the shape.
	virtual void OnDrawFlat(CDC *pDC);

	// Draws shadow of shape.
	virtual void OnDrawShadow(CDC *pDC);

	// Draws the 3D status of the shape.
	virtual void OnDraw3d(CDC *pDC);

	// Frees GDI objects and restores the state of the device context.
	virtual void ClearDC(CDC* pDC);
	// Implementation

// Do show timer.
	virtual void OnTimer( int nTimerID );

	// Is position correct.
	BOOL PositionCorrect();

	// Start timer
	void DoStartTimer();

	// Set wnd handle.
	// pWnd -- pointer of parent wnd.
	virtual void SetParentWnd(CFOPCanvasCore *pWnd);

public:

#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif
	
protected:
	// Current timer ID
	int					m_nTimerID;

	double				dMin;
	double				dHour;
	double				dSecond;
};



#endif // !defined(FO_EXTCLOCKSHAPE_H__FB79CEA5_568C_4287_8B25_AEF55B063FF0__INCLUDED_)
